/*----------------------------------------------------------------------------

	glob.c

	This file contains declarations for all the global variables.
	
	Copyright  1994, Northwestern University.

----------------------------------------------------------------------------*/

#include "glob.h"

TDispatch gDispatch[kNumWindowKind];	/* dispatch table */

short gNumGroups = 0;					/* number of newsgroups */
TGroup **gFullGroupArray = nil;			/* handle to full group array */
Handle gGroupNames = nil;				/* handle to group name strings */
WindowPtr gFullGroupWindow = nil;		/* pointer to full group list window */
Boolean gFullGroupListDirty = false;	/* true if full group list dirty */
Boolean gMustDoZoomOnShowFullGroupList = true;
										/* true if full group list needs zooming */

TPrefRec gPrefs;						/* preferences */

CStr255 gAutoFetchHost;					/* autofetch host */
CStr255 gAutoFetchUsername;				/* autofetch username */
char gAutoFetchPassword[32];			/* autofetch password */
char gAutoFetchPath[32];				/* autofetch path */

Boolean gDone = false;					/* flag set true upon program termination */
Boolean gCancel = false;				/* flag set when user cancels an action */
Boolean gStartupOK = true;				/* true if no errors during startup */
Boolean gStartingUp = true;				/* true during startup */
extern Boolean gPrefsFileFoundAtStartup = false;	/* true if prefs file found during startup */
Boolean gLongOperation = false;			/* true during long operations */
Boolean gInDialog = false;				/* true while in dialog */
Boolean gInBackground;					/* background/foreground flag */
Boolean gAEServer = false;				/* true while responding to Apple event */
DialogPtr gMyCurDialog = nil;			/* pointer to NewsWatcher's current dialog
								     	   window, or nil if none */
Rect gDesktopExtent;					/* desktop extent */
Cursor gIBeamCurs;						/* ibeam cursor */
Cursor gWatchCurs;						/* watch cursor */

Boolean gHaveDragMgr;					/* true if Drag Manager is available */
OSErr (*gDragPostProcessor)(void) = nil;	/* pointer to drag and drop post-processing
										       function, or nil if none */
OSErr gDragErr = noErr;					/* Drag Manager handler error code. */

EventRecord gCurEvent = {0, 0, 0, {0, 0}, 0};					
										/* current event being handled */
EventRecord gPrevEvent = {0, 0, 0, {0, 0}, 0};					
										/* previous event */

Boolean gHaveTEOutlineHilite;			/* true if TE outline hilight feature
										   is available */
										   
CStr255 gFindPattern = "";				/* pattern for Find and Find Again commands */