#define kMBarID				128			/* resource id of MBAR rsrc */
#define kEntireMenuMask		0x00000001	/* mask for enabling an entire menu */



/*	Apple menu. */

#define kAppleMenu				128

#define kAboutNewsWatcherItem	1

#define kAppleAllEnabled			0xfffffffb
#define kAppleAllDisabled			0
#define kAppleOnlyAboutDisabled		0xfffffff9



/*	File menu. */

#define kFileMenu				129

#define kNewGroupWindowItem			1
#define kOpenItem					2
#define kCloseItem					3
#define kSaveItem					5
#define kSaveAsItem					6
#define kAppendItem					7
#define kPageSetupItem				9
#define kPrintItem					10
#define kPreferencesItem			12
#define kQuitItem					14

#define kNumFileMenuItems			14

#define	kNewGroupWindowMask			(1L << kNewGroupWindowItem)
#define kOpenMask					(1L << kOpenItem)
#define kCloseMask					(1L << kCloseItem)
#define kSaveMask					(1L << kSaveItem)
#define kSaveAsMask					(1L << kSaveAsItem)
#define kAppendMask					(1L << kAppendItem)
#define kPageSetupMask				(1L << kPageSetupItem)
#define kPrintMask					(1L << kPrintItem)
#define kPreferencesMask            (1L << kPreferencesItem)
#define kQuitMask					(1L << kQuitItem)

#define kNoneFileEnabled ( \
	kNewGroupWindowMask | \
	kOpenMask | \
	kPageSetupMask | \
	kPreferencesMask | \
	kQuitMask)
	
#define kDAFileEnabled ( \
	kNewGroupWindowMask | \
	kOpenMask | \
	kPageSetupMask | \
	kPreferencesMask | \
	kQuitMask)
	
#define kGroupFileEnabled ( \
	kNewGroupWindowMask | \
	kOpenMask | \
	kCloseMask | \
	kPageSetupMask | \
	kPreferencesMask | \
	kQuitMask)
	
#define kNewGroupFileEnabled ( \
	kNewGroupWindowMask | \
	kOpenMask | \
	kCloseMask | \
	kPageSetupMask | \
	kPreferencesMask | \
	kQuitMask)
		
#define kUserGroupFileEnabled ( \
	kNewGroupWindowMask | \
	kOpenMask | \
	kCloseMask | \
	kSaveMask | \
	kSaveAsMask | \
	kPageSetupMask | \
	kPreferencesMask | \
	kQuitMask)
	
#define kSubjectFileEnabled ( \
	kNewGroupWindowMask | \
	kOpenMask | \
	kCloseMask | \
	kSaveMask | \
	kSaveAsMask | \
	kAppendMask | \
	kPageSetupMask | \
	kPrintMask | \
	kPreferencesMask | \
	kQuitMask)
	
#define kArticleFileEnabled ( \
	kNewGroupWindowMask | \
	kOpenMask | \
	kCloseMask | \
	kSaveMask | \
	kSaveAsMask | \
	kAppendMask | \
	kPageSetupMask | \
	kPrintMask | \
	kPreferencesMask | \
	kQuitMask)
	
#define kMessageFileEnabled ( \
	kNewGroupWindowMask | \
	kOpenMask | \
	kCloseMask | \
	kSaveMask | \
	kSaveAsMask | \
	kPageSetupMask | \
	kPrintMask | \
	kPreferencesMask | \
	kQuitMask)
	
#define kTextFileEnabled ( \
	kNewGroupWindowMask | \
	kOpenMask | \
	kCloseMask | \
	kSaveMask | \
	kSaveAsMask | \
	kPageSetupMask | \
	kPrintMask | \
	kPreferencesMask | \
	kQuitMask)
	
#define kStartupBadFileEnabled ( \
	kPreferencesMask | \
	kQuitMask)



/*	Edit menu. */

#define kEditMenu				130

#define kUndoItem					1
#define kCutItem					3
#define kCopyItem					4
#define kPasteItem					5
#define kPasteAsQuotationItem		6
#define kClearItem					7
#define kSelectAllItem				8
#define kDeselectAllItem			9
#define kFindItem					11
#define kFindAgainItem				12
#define kEnterSelectionItem			13
#define kShowHideDetailsItem		15
#define kRot13Item					16
#define kInsertSpoilerCharacterItem	17
#define kWrapItem					19
#define kUnwrapItem					20

#define kNumEditMenuItems		20

#define kUndoMask					(1L << kUndoItem)
#define kCutMask					(1L << kCutItem)
#define kCopyMask					(1L << kCopyItem)
#define kPasteMask					(1L << kPasteItem)
#define kPasteAsQuotationMask		(1L << kPasteAsQuotationItem)
#define kClearMask					(1L << kClearItem)
#define kSelectAllMask				(1L << kSelectAllItem)
#define kDeselectAllMask			(1L << kDeselectAllItem)
#define kFindMask					(1L << kFindItem)
#define kFindAgainMask				(1L << kFindAgainItem)
#define kEnterSelectionMask			(1L << kEnterSelectionItem)
#define kShowHideDetailsMask		(1L << kShowHideDetailsItem)
#define kRot13Mask					(1L << kRot13Item)
#define kInsertSpoilerCharacterMask	(1L << kInsertSpoilerCharacterItem)
#define kWrapMask					(1L << kWrapItem)
#define kUnwrapMask					(1L << kUnwrapItem)

#define kNoneEditEnabled		0

#define kEditOnlyCopyEnabled ( \
	kCopyMask)

#define kDAEditEnabled ( \
	kUndoMask | \
	kCutMask | \
	kCopyMask | \
	kPasteMask | \
	kClearMask)
	
#define kGroupEditEnabled ( \
	kCopyMask | \
	kSelectAllMask | \
	kDeselectAllMask | \
	kFindMask | \
	kFindAgainMask )
	
#define kNewGroupEditEnabled ( \
	kCopyMask | \
	kSelectAllMask | \
	kDeselectAllMask | \
	kFindMask | \
	kFindAgainMask)
	
#define kUserGroupEditEnabled ( \
	kCutMask | \
	kCopyMask | \
	kPasteMask | \
	kClearMask | \
	kSelectAllMask | \
	kDeselectAllMask | \
	kFindMask | \
	kFindAgainMask)
	
#define kSubjectEditEnabled ( \
	kSelectAllMask | \
	kDeselectAllMask | \
	kFindMask | \
	kFindAgainMask)
	
#define kArticleEditEnabled ( \
	kCopyMask | \
	kSelectAllMask | \
	kFindMask | \
	kFindAgainMask | \
	kEnterSelectionMask | \
	kShowHideDetailsMask | \
	kRot13Mask)
	
#define kMessageEditEnabled ( \
	kCutMask | \
	kCopyMask | \
	kPasteMask | \
	kPasteAsQuotationMask | \
	kClearMask | \
	kSelectAllMask | \
	kFindMask | \
	kFindAgainMask | \
	kEnterSelectionMask | \
	kShowHideDetailsMask | \
	kRot13Mask | \
	kInsertSpoilerCharacterMask | \
	kWrapMask | \
	kUnwrapMask)
	
#define kTextEditEnabled ( \
	kCopyMask | \
	kSelectAllMask | \
	kFindMask | \
	kFindAgainMask | \
	kEnterSelectionMask)
	
#define kStartupBadEditEnabled	0



/*	News menu. */

#define kNewsMenu				131

#define kNextArticleItem			1
#define kNextThreadItem				2
#define kNextGroupItem				3
#define kMarkReadItem				5
#define kMarkUnreadItem				6
#define kMarkOthersReadItem			7
#define kNewMessageItem				9
#define kReplyItem					10
#define kForwardItem				11
#define kRedirectItem				12
#define kSendMessageItem			13
#define kCheckForNewArticlesItem	15

#define kNumNewsMenuItems		15

#define kNextArticleMask			(1L << kNextArticleItem)
#define kNextThreadMask				(1L << kNextThreadItem)
#define kNextGroupMask				(1L << kNextGroupItem)
#define kMarkReadMask				(1L << kMarkReadItem)
#define kMarkUnreadMask				(1L << kMarkUnreadItem)
#define kMarkOthersReadMask			(1L << kMarkOthersReadItem)
#define kNewMessageMask				(1L << kNewMessageItem)
#define kReplyMask					(1L << kReplyItem)
#define kForwardMask				(1L << kForwardItem)
#define kRedirectMask				(1L << kRedirectItem)
#define kSendMessageMask			(1L << kSendMessageItem)
#define kCheckForNewArticlesMask	(1L << kCheckForNewArticlesItem)

#define kNoneNewsEnabled ( \
	kNewMessageMask)
	
#define kDANewsEnabled ( \
	kNewMessageMask)
	
#define kGroupNewsEnabled ( \
	kNextArticleMask | \
	kNextThreadMask | \
	kNextGroupMask | \
	kNewMessageMask)
	
#define kNewGroupNewsEnabled ( \
	kNextArticleMask | \
	kNextThreadMask | \
	kNextGroupMask | \
	kNewMessageMask)
	
#define kUserGroupNewsEnabled ( \
	kNextArticleMask | \
	kNextThreadMask | \
	kNextGroupMask | \
	kMarkReadMask | \
	kMarkUnreadMask | \
	kNewMessageMask | \
	kCheckForNewArticlesMask)
	
#define kSubjectNewsEnabled ( \
	kNextArticleMask | \
	kNextThreadMask | \
	kNextGroupMask | \
	kMarkReadMask | \
	kMarkUnreadMask | \
	kMarkOthersReadMask | \
	kReplyMask | \
	kForwardMask | \
	kRedirectMask | \
	kNewMessageMask)
	
#define kArticleNewsEnabled ( \
	kNextArticleMask | \
	kNextThreadMask | \
	kNextGroupMask | \
	kMarkReadMask | \
	kMarkUnreadMask | \
	kReplyMask | \
	kForwardMask | \
	kRedirectMask | \
	kNewMessageMask)
	
#define kArticleNewsEnabledNoParent	( \
	kReplyMask | \
	kForwardMask | \
	kRedirectMask | \
	kNewMessageMask)
	
#define kMessageNewsEnabled ( \
	kNewMessageMask | \
	kSendMessageMask)
	
#define kTextNewsEnabled ( \
	kNewMessageMask)
	
#define kStartupBadNewsEnabled	0



/*	Special menu. */

#define kSpecialMenu			132

#define kExtractBinariesItem			1
#define kExtractBinariesManuallyItem	2
#define kGetGroupListFromHostItem		4
#define kSendGroupListToHostItem		5
#define kOpenAllReferencesItem			7
#define kSearchItem						8
#define kGetServerInfoItem				9
#define kCancelArticleItem				10
#define kOpenURLItem					11
#define kCheckForNewGroupsItem			13
#define kCheckForDeletedGroupsItem		14
#define kRebuildFullGroupListItem		15
#define kSubscribeItem					17
#define kUnsubscribeItem				18

#define kNumSpecialMenuItems	18

#define kExtractBinariesMask			(1L << kExtractBinariesItem)
#define kExtractBinariesManuallyMask	(1L << kExtractBinariesManuallyItem)
#define kGetGroupListFromHostMask		(1L << kGetGroupListFromHostItem)
#define kSendGroupListToHostMask		(1L << kSendGroupListToHostItem)
#define kOpenAllReferencesMask			(1L << kOpenAllReferencesItem)
#define kSearchMask						(1L << kSearchItem)
#define kGetServerInfoMask				(1L << kGetServerInfoItem)
#define kCancelArticleMask				(1L << kCancelArticleItem)
#define kOpenURLMask					(1L << kOpenURLItem)
#define kCheckForNewGroupsMask			(1L << kCheckForNewGroupsItem)
#define kCheckForDeletedGroupsMask		(1L << kCheckForDeletedGroupsItem)
#define kRebuildFullGroupListMask		(1L << kRebuildFullGroupListItem)
#define kSubscribeMask					(1L << kSubscribeItem)
#define kUnsubscribeMask				(1L << kUnsubscribeItem)

#define kNoneSpecialEnabled	( \
	kGetGroupListFromHostMask | \
	kGetServerInfoMask | \
	kCheckForNewGroupsMask | \
	kCheckForDeletedGroupsMask | \
	kRebuildFullGroupListMask)

#define kDASpecialEnabled ( \
	kGetGroupListFromHostMask | \
	kGetServerInfoMask | \
	kCheckForNewGroupsMask | \
	kCheckForDeletedGroupsMask | \
	kRebuildFullGroupListMask)
	
#define kGroupSpecialEnabled (\
	kGetGroupListFromHostMask | \
    kSearchMask | \
    kGetServerInfoMask | \
	kCheckForNewGroupsMask | \
	kCheckForDeletedGroupsMask | \
	kRebuildFullGroupListMask | \
	kSubscribeMask)
	
#define kNewGroupSpecialEnabled	(\
	kGetGroupListFromHostMask | \
    kSearchMask | \
    kGetServerInfoMask | \
	kCheckForNewGroupsMask | \
	kCheckForDeletedGroupsMask | \
	kRebuildFullGroupListMask | \
	kSubscribeMask)
	
#define kUserGroupSpecialEnabled (\
	kGetGroupListFromHostMask | \
	kSendGroupListToHostMask | \
    kSearchMask | \
    kGetServerInfoMask | \
	kCheckForNewGroupsMask | \
	kCheckForDeletedGroupsMask | \
	kRebuildFullGroupListMask | \
	kUnsubscribeMask)
	
#define kSubjectSpecialEnabled	(\
	kExtractBinariesMask | \
	kExtractBinariesManuallyMask | \
	kGetGroupListFromHostMask | \
    kSearchMask | \
    kGetServerInfoMask | \
    kCancelArticleMask | \
	kCheckForNewGroupsMask | \
	kCheckForDeletedGroupsMask | \
	kRebuildFullGroupListMask)
	
#define kArticleSpecialEnabled	(\
	kExtractBinariesMask | \
	kGetGroupListFromHostMask | \
    kOpenAllReferencesMask | \
    kSearchMask | \
    kGetServerInfoMask | \
    kCancelArticleMask | \
    kOpenURLMask | \
	kCheckForNewGroupsMask | \
	kCheckForDeletedGroupsMask | \
	kRebuildFullGroupListMask)
	
#define kMessageSpecialEnabled (\
	kGetGroupListFromHostMask | \
    kGetServerInfoMask | \
    kOpenURLMask | \
	kCheckForNewGroupsMask | \
	kCheckForDeletedGroupsMask | \
	kRebuildFullGroupListMask)
	
#define kTextSpecialEnabled	(\
	kGetGroupListFromHostMask | \
    kGetServerInfoMask | \
    kOpenURLMask | \
	kCheckForNewGroupsMask | \
	kCheckForDeletedGroupsMask | \
	kRebuildFullGroupListMask)
	
#define kStartupBadSpecialEnabled	0



/*	Windows menu. */

#define kWindMenu				133

#define kCycleWindowsItem			1
#define kZoomWindowItem				2
#define kShowHideFullGroupListItem	4
#define kFirstOpenWindItem			6

#define kNumWindMenuItems		4

#define kCycleWindowsMask			(1L << kCycleWindowsItem)
#define kZoomWindowMask				(1L << kZoomWindowItem)
#define kShowHideFullGroupListMask	(1L << kShowHideFullGroupListItem)

#define kNoneWindEnabled ( \
	kShowHideFullGroupListMask)

#define kDAWindEnabled ( \
	kShowHideFullGroupListMask)
	
#define kGroupWindEnabled ( \
	kCycleWindowsMask | \
	kZoomWindowMask | \
	kShowHideFullGroupListMask)
	
#define kNewGroupWindEnabled ( \
	kCycleWindowsMask | \
	kZoomWindowMask | \
	kShowHideFullGroupListMask)
	
#define kUserGroupWindEnabled ( \
	kCycleWindowsMask | \
	kZoomWindowMask | \
	kShowHideFullGroupListMask)
	
#define kSubjectWindEnabled ( \
	kCycleWindowsMask | \
	kZoomWindowMask | \
	kShowHideFullGroupListMask)
	
#define kArticleWindEnabled ( \
	kCycleWindowsMask | \
	kZoomWindowMask | \
	kShowHideFullGroupListMask)
	
#define kMessageWindEnabled	( \
	kCycleWindowsMask | \
	kZoomWindowMask | \
	kShowHideFullGroupListMask)
	
#define kTextWindEnabled ( \
	kCycleWindowsMask | \
	kZoomWindowMask | \
	kShowHideFullGroupListMask)
	
#define kStartupBadWindEnabled	0


void SetMenusTo (
	unsigned long newAppleMenuState,
	unsigned long newFileMenuState, 
	unsigned long newEditMenuState,
	unsigned long newNewsMenuState, 
	unsigned long newSpecialMenuState, 
	unsigned long newWindMenuState);
void SetWindowsMenuShowHideFullGroupList (Boolean show);
void SetEditMenuShowHideDetails (Boolean show);
void AdjustExtractBinariesCommand (void);
void AdjustCycleWindowsCommand (void);
