typedef OSErr (*NetGiveTimeFunction) (Boolean waiting);
typedef void (*NetLogFunction) (Boolean command, unsigned long addr,
	char *str);
typedef void (*NetDoOneResponse) (long responseCode, CStr255 response);
typedef Boolean (*NetTruncateFunction) (Handle t, long tLen, long *pos);
typedef OSErr (*NetChunkFunction) (Ptr t, long tLen, Boolean *abort);

typedef Handle NetStreamHandle;

OSErr NetInit (NetGiveTimeFunction giveTime, NetLogFunction log, short numBuffs);
OSErr NetIdle (void);
OSErr NetTerm (void);

OSErr NetOpen (unsigned long addr, unsigned short port, NetStreamHandle *stream, 
	long *responseCode, CStr255 response);
OSErr NetClose (NetStreamHandle stream);
OSErr NetCommand (NetStreamHandle stream, char *command, 
	long *responseCode, CStr255 response);
OSErr NetGetExtraResponse (NetStreamHandle stream, long *responseCode, 
	CStr255 response);
OSErr NetBatchedCommands (NetStreamHandle stream, Handle commands, 
	NetDoOneResponse doOneResponse);
OSErr NetSendText (NetStreamHandle stream, Handle text);
OSErr NetGetText (NetStreamHandle stream, Handle *text);
OSErr NetGetTextWithTruncation (NetStreamHandle stream, NetTruncateFunction truncateFunction,
	Handle *text, Boolean *truncated);
OSErr NetGetChunkyText (NetStreamHandle stream, NetChunkFunction chunkFunction,
	Boolean *aborted);

OSErr NetFTPDataOpen (unsigned short *port, NetStreamHandle *stream);
OSErr NetFTPDataClose (NetStreamHandle stream);
OSErr NetFTPDataWaitForConnection (NetStreamHandle stream);
OSErr NetSendFTPTextFile (NetStreamHandle stream, Handle text);
OSErr NetGetFTPTextFile (NetStreamHandle stream, Handle *text);

OSErr NetGetMyAddr (unsigned long *addr);
OSErr NetGetMyAddrStr (char *addrStr);
OSErr NetGetMyName (CStr255 name);
OSErr NetNameToAddr (char *name, unsigned short defaultPort, 
	unsigned long *addr, unsigned short *port);
OSErr NetAddrToName (unsigned long addr, CStr255 name);

OSErr NetGiveTime (Boolean waiting);
Boolean NetDNROperationInProgress (void);

void net_InitUPP (void);