#ifndef _H_SORTSYS
#define _H_SORTSYS

/* boolean */
typedef enum { FALSE, TRUE } bool;

/* convenient constant for calculating microseconds */
#define MILLION (1000000)

/* ugly system dependent definitions */
#ifndef CLOCKS_PER_SEC
  #if SYS_NEXT || SYS_ULTRIX
    #define CLOCKS_PER_SEC CLK_TCK
  #elif SYS_UNIX
      /* Many Unix systems don't have the clock() function yet, so
         I had to make my own version in "ansi.c"; it returns
         the current time in microseconds. */
      #define CLOCKS_PER_SEC MILLION
  #endif
#endif /* CLOCKS_PER_SEC */

void profile_init(void);
void profile_start(void);
void profile_stop(void);
void profile_dump(void);

void sysinit(void);
void sysinfomac(char *mc_name, char *os_name, char *cc_name);

#endif /* _H_SORTSYS */
